<?php

namespace Dao;
use Conn\MySqlConnect;

/**
 * Description of Sobre
 *
 * @author Délio
 */
class Sobre {
    
    public $id;
    public $titulo;
    public $texto;
    public $ordem;
    public $image;
    public $data_cadastro;
    public $usuario_cadastrou;
    public $data_alteracao;
    public $usuario_alterou;
    public $status;
    public $slug;

    function __construct($res = null) {
        $this->id = (int) 0;
        $this->titulo = (string) '';
        $this->texto = (string) '';
        $this->ordem = (int) 0;
        $this->image = (string) '';
        $this->data_cadastro = (string) date('Y-m-d H:i:s');
        $this->usuario_cadastrou = (int) 0;
        $this->data_alteracao = (string) date('Y-m-d H:i:s');
        $this->usuario_alterou = (int) 0;
        $this->status = (string) 'A';
        $this->slug = (string) '';
        $this->fill($res);
    }
    
    private function fill($res) {
        if ($res != null && $res instanceof \stdClass) {
            $this->id = (int) (isset($res->id) ? $res->id : 0);
            $this->titulo = (string) (isset($res->titulo) ? $res->titulo : '');
            $this->texto = (string) (isset($res->texto) ? $res->texto : '');
            $this->ordem = (int) (isset($res->ordem) ? $res->ordem : 0);
            $this->image = (string) (isset($res->image) ? $res->image : '');
            $this->data_cadastro = (string) (isset($res->data_cadastro) ? $res->data_cadastro : null);
            $this->usuario_cadastrou = (int) (isset($res->usuario_cadastrou) ? $res->usuario_cadastrou : 0);
            $this->data_alteracao = (string) (isset($res->data_alteracao) ? $res->data_alteracao : null);
            $this->usuario_alterou = (int) (isset($res->usuario_alterou) ? $res->usuario_alterou : 0);
            $this->status = (string) (isset($res->status) ? $res->status : 'A');
            $this->slug = (string) (isset($res->slug) ? $res->slug : '');
        }
    }

    private function inserir(MySqlConnect $conecta) {
        $sql = $conecta->prepare("INSERT INTO sobre (titulo, texto, ordem, image, data_cadastro, usuario_cadastrou, status, slug) VALUES (?, ?, ?, ?, ?, "
                . "?, ?, ?)") or die($conecta->error);
        $sql->bind_param("ssississ", $this->titulo, $this->texto, $this->ordem, $this->image, $this->data_cadastro, $this->usuario_cadastrou, $this->status, 
                $this->slug);
        if ($sql->execute())
            return json_encode(['data' => 'Success', 'message' => 'Texto inserido com sucesso!', 'id' => $sql->insert_id]);
        return json_encode(['data' => 'Error', 'message' => $sql->error, 'id' => 0]);
    }
    
    private function editar(MySqlConnect $conecta) {
        $sql = $conecta->prepare("UPDATE sobre SET titulo = ?, texto = ?, image = ?, data_alteracao = ?, usuario_alterou = ?, slug = ? WHERE id = ?") or die($conecta->error);
        $sql->bind_param("ssssisi", $this->titulo, $this->texto, $this->image, $this->data_alteracao, $this->usuario_alterou, $this->slug, $this->id);
        if ($sql->execute())
            return json_encode(['data' => 'Success', 'message' => 'Texto atualizado com sucesso!', 'id' => $this->id]);
        return json_encode(['data' => 'Error', 'message' => $sql->error, 'id' => $this->id]);
    }
    
    function salvar(MySqlConnect $conecta) {
        if ($this->id == 0)
            return $this->inserir($conecta);
        return $this->editar($conecta);
    }
    
    function excluir(MySqlConnect $conecta) {
        $sql = $conecta->prepare("UPDATE sobre SET data_alteracao = ?, usuario_alterou = ?, status = ? WHERE id = ?") or die($conecta->error);
        $sql->bind_param("sisi", $this->data_alteracao, $this->usuario_alterou, $this->status, $this->id);
        if ($sql->execute())
            return json_encode(['data' => 'Success', 'message' => 'Texto excluido com sucesso!', 'id' => $this->id]);
        return json_encode(['data' => 'Error', 'message' => $sql->error, 'id' => $this->id]);
    }
    
    function getLista(MySqlConnect $conecta, $where = '') {
        $lst_sobre = [];
        $sql = $conecta->query("SELECT * FROM sobre WHERE status = 'A' $where") or die($conecta->error);
        while ($res = $sql->fetch_object())
            $lst_sobre[] = new Sobre($res);
        return $lst_sobre;
    }
    
    function getTextoPorId(MySqlConnect $conecta, $id) {
        $sql = $conecta->query("SELECT * FROM sobre WHERE id = '$id' AND status = 'A'") or die($conecta->error);
        if ($sql->num_rows > 0) {
            $res = $sql->fetch_object();
            $this->fill($res);
        }
    }
    
    function getTextoPorSlug(MySqlConnect $conecta, $slug) {
        $sql = $conecta->query("SELECT id FROM sobre WHERE slug = '$slug' AND status = 'A'") or die($conecta->error);
        if ($sql->num_rows > 0) {
            $res = $sql->fetch_object();
            $this->getTextoPorId($conecta, $res->id);
        }
    }
}